#!/usr/bin/perl

######################################################################
package Cognition::uF::hTodo;
######################################################################

use XML::LibXML qw(:all);
use strict;
use CGI::Util;
use Digest::SHA1 qw(sha1_hex);

BEGIN
{
	our $VERSION = 0.1;
	our @ISA = qw(Cognition::uF);
}


sub MAX_INCLUDE_ITERATIONS { 6; }


sub parse_all
{
	my $page   = shift;
	my $within = shift || $page->{DOM};
	my @nodes = Cognition::HTMLParser::Utils::searchClass('vtodo', $within);
	my @rv;
	
	foreach my $ev (@nodes)
	{
		push @rv, parse($page, $ev);
	}
	
	return @rv;
} #/sub parse_all


sub uri
{
	my $this = shift;
	my $all  = shift;
	my @rv;
	
	if (length $this->{uid})
	{
		my $uid = $this->{uid};
		$uid = "urn:x-uid:$uid"
			unless ($uid =~ /^[a-z0-9]{1,10}\:/i);
		push @rv, $uid;
	}
	if (length $this->{_id})
	{
		push @rv, $this->{_page}->abs_url.'#'.$this->{_id};
	}
	if (length $this->{summary})
	{
		push @rv, 'urn:x-vtodo:' . CGI::Util::escape($this->{summary});
	}
	push @rv, Cognition::HTMLParser::Utils::XPointer($this->{_dom}, $this->{_page}->abs_url);
	
	return $rv[0] unless (defined $all);
	while ($all) { shift @rv; $all--; }
	return @rv;
} #/sub uri


sub rdf_subject
{
	return Cognition::uF::hEvent::rdf_subject(@_, 'Cognition::uF::hTodo');
}

sub metadata_ns
{
	return Cognition::uF::hEvent::metadata_ns(@_, 'Cognition::uF::hTodo');
}

sub parse
{
	return Cognition::uF::hEvent::parse(@_, 'Cognition::uF::hTodo');
} #/sub parse


1; #/package Cognition::uF::hTodo




